/****************************************************************************
 * <Novell-copyright>
 * Copyright (c) 2001 Novell, Inc. All Rights Reserved.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of version 2 of the GNU General Public License
 * as published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, contact Novell, Inc.
 * 
 * To contact Novell about this file by physical or electronic mail, you 
 * may find current contact information at www.novell.com.
 * </Novell-copyright>
 ****************************************************************************/


typedef enum /* all symbols */
{
    UIDsy = 1,    SEARCHsy,        CHARSETsy,     BODYsy,
    TEXTsy,       TOsy,            FROMsy,        SUBJECTsy,
    CCsy,         BCCsy,           HEADERsy,      NEWsy,
    OLDsy,        RECENTsy,        ANSWEREDsy,    UNANSWEREDsy,
    DELETEDsy,    UNDELETEDsy,     DRAFTsy,       UNDRAFTsy,
    FLAGGEDsy,    UNFLAGGEDsy,     SEENsy,        UNSEENsy,
    KEYWORDsy,    UNKEYWORDsy,     LARGERsy,      SMALLERsy,
    NOTsy,        ORsy,            BEFOREsy,      ONsy,
    SINCEsy,      SENTBEFOREsy,    SENTONsy,      SENTSINCEsy,
    ALLsy,        spacesy,         largestsy,     nz_numbersy,  
    atomsy,       stringsy,        endofbufsy,    crlfsy,
    crsy,         lfsy,            lbracesy,      rbracesy,
    commasy,      colonsy,         lparensy,      rparensy,
    lbracksy,     rbracksy,        numbersy,      datesy,
    errorsy
} SYMBOL;

#define IDENTSIZE 100
#define BUFSIZE    1023

typedef struct
{
    SYMBOL sy;                           /* current symbol */
    unsigned char ch;                    /* current char */
    int offsetIn;                        /* current offset of bufferIn (Command) */
    int offsetOut;                       /* current offset of bufferIn */
    unsigned char bufferOut[ BUFSIZE+1]; /* bufferOut to NMAP */
    int identStart;                      /* identifier offset start */
    unsigned long identLen;              /* identifier length */
    unsigned char ident[ IDENTSIZE+2];   /* current identifier */
    BOOL resultByPosition;               /* search results by position or by uid */
    /*int numSearchKeys; */              /* number of search keys */
    unsigned char *Command;              /* short cut to Client->Command */
    void *Client;                        /* JIC baggage */
    unsigned long msgCount;
    unsigned long bvByteSize;
    unsigned long identNum;
    int messageSet;
} IMAPSEARCH;
