/****************************************************************************
 *
 * Copyright (c) 2005 Novell, Inc.
 * All Rights Reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of version 2.1 of the GNU Lesser General Public
 * License as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, contact Novell, Inc.
 *
 * To contact Novell about this file by physical or electronic mail,
 * you may find current contact information at www.novell.com
 *
 ****************************************************************************/
using System;
using System.Collections;

using NUnit.Framework;

namespace Hula.Nmap
{
[TestFixture]
public class NmapClientTest : NmapTest
{
    [Test]
    public void NmapVersion()
    {
        Assert.IsTrue(nc.Open.NVER().StartsWith("1.4"));
    }

    [Test]
    public void NmapError()
    {
        Assert.AreEqual(nc.Open.ERRO(), "Error requested");
    }

    [Test]
    public void NmapConf()
    {
        Assert.IsTrue(nc.Open.CONF().Contains("Server DN"));
    }

    [Test]
    public void NmapUserList()
    {
        Assert.IsTrue(nc.Open.ULIST().Contains("admin"));
    }

    [Test]
    public void NmapCapabilityList()
    {
        Assert.IsTrue(nc.Open.CAPA().Contains("NMAP2 NMAP Protocol Version 2"));
    }

    [Test]
    public void NmapSwitchUser()
    {
        nc.Auth.USER("admin");
        nc.Open.RSET(RsetFlag.User);
        Assert.IsTrue(true);
    }

    [Test]
    public void ListMailboxes()
    {
        nc.Auth.USER("admin");

        IList list = nc.User.SHOW("%");

        Assert.IsTrue(list.Contains("INBOX"));
    }
}
}
