#ifdef WIN32
#include <config.h>
#include <windows.h>
#include <stdio.h>
#include <direct.h>
#include <process.h>
#include <lm.h>

#include <xpl.h>

#define	PRODUCT_SHORT_NAME	"hulaprep.exe"

#define	HULA_SERVICE_USER	"HulaService"


BOOL	GrantServiceRights(unsigned char *User);
BOOL	AutoStart=TRUE;

typedef struct {	
	unsigned char	*ShortName;
	unsigned char	*Name;
	unsigned char	*Executable;
	BOOL				AutoStart;
	unsigned char	*Description;
} HulaAgentStruct;

HulaAgentStruct	Agents[] = {
    "hulanmapd.nlm",		"Hula NMAP Agent",		"hulanmapd.exe",		0, "Provides mail-store access and message queueing services via the NMAP protocol.",
	"hulamsgalias.nlm",	"Hula Alias Agent",		"hulamsgalias.exe",	0, "Provides automatic generation and translation of addresses.",
	"hulaantispam.nlm",	"Hula AntiSpam Agent",	"hulaantispam.exe",	0, "Allows to filter out unwanted messages that may have been sent to the Hula messaging system.",
	"hulaavirus.nlm",		"Hula AntiVirus Agent",	"hulaavirus.exe",		0, "Allows to scan all messages passing through the mail system for viruses. Requires 3rd party virus-scan engine.",
	"hulacalagent.nlm",	"Hula Calendar Agent",	"hulacalagent.exe",	0, "Provides automatic processing of calendar events users receive.",
	"hulaforward.nlm",		"Hula Forward Agent",	"hulaforward.exe",		0, "Provides forwarding and auto-reply functionality for Hula  users.",
	"hulagkeeper.nlm",		"Hula Connection Manager",	"hulagkeeper.exe",	0, "Required to provide management of SMTP-after-POP functionality for Hula .",
	"hulaimapd.nlm",		"Hula IMAP4 Agent",		"hulaimap.exe",		0, "Provices IMAP4 access to the Hula mail-store. (IMAP4 = Internet Mail Access Protocol, Rev4, RFC2060)",
	"hulalist.nlm",		"Hula List Agent",		"hulalist.exe",		0, "Provides a full-featured mailing-list server.",
	"hulamsgldap.nlm",		"Hula Address Book Agent",	"hulamsgldap.exe",	0, "Allows clients to look up email addresses on this host via the LDAP protocol. (LDAP = Lightweight Directory Access Protocol)",
	"hulamodwebd.nlm",		"Hula Modular Web Agent",	"hulamodweb.exe",	0, "Provides webclient access to Hula services like mail, calendar, user preferences, etc.",
	"hulapluspack.nlm",	"Hula PlusPack Agent",	"hulapluspack.exe",	0, "Provides automatic copying of outgoing messages, automatic signature and access control for remote sending.",
	"hulapop3d.nlm",		"Hula POP3 Agent",		"hulapop3d.exe",		0, "Enables POP3 clients to retrieve mail from this host. (POP3 = Post Office Protocol, Version 3, RFC 1939)",
	"hulamailprox.nlm",	"Hula Proxy Agent",		"hulamailprox.exe",	0, "Provides the ability for users to transfer mail from other mail systems into their Hula account.",
	"hularules.nlm",		"Hula Rule Agent",		"hularules.exe",		0, "Provide processing of user-created message rules.",
	"hulasmtp.nlm",		"Hula SMTP Agent",		"hulasmtp.exe",		0, "Allows mail-clients and other mail-servers to deliver mail to this host via the SMTP protocol. (SMTP = Simple Mail Transfer Protocol, RFC 2821)",
    "Hula",			"Hula Manager",			"hulamanager.exe",			1, "Automatically starts Hula Agents based on the system configuration.",
#if defined(HULAXE)
	"webadm.nlm",		"Hula Web Administration",	"webadm.exe",	0, "Starts the Hula Web-based administration interface",
#else
	"hulawebadmin.nlm",	"Hula Web Administration",	"hulawebadmin.exe",	0, "Starts the Hula Web-based administration interface",
#endif
	NULL, NULL, NULL, 0, NULL
};

SC_HANDLE		Manager;

int
UTF8EncodeChar(unicode unichar, unsigned char *dest)
{
	if (unichar < 0x0080) {					/* 0000-007F */
		dest[0] = (char)(unichar);
		return(1);
	}
	if (unichar < 0x0800) {					/* 0080-07FF */
		dest[0] = (char)(0xC0 | ((unichar & 0x07C0) >> 6));
		dest[1] = (char)(0x80 | (unichar & 0x003F));
		return(2);
	}
														/* 0800-FFFF */
	dest[0] = (char)(0xE0 | ((unichar & 0xF000) >> 12));
	dest[1] = (char)(0x80 | ((unichar & 0x0FC0) >> 6));
	dest[2] = (char)(0x80 | (unichar & 0x003F));
	return(3);	
}

/* This function only handles UCS-2 */
int
UTF8DecodeChar(const unsigned char *src, unicode *uchar)
{
	if (src[0] <= 0x7F) {			/* 0000-007F: one byte (0xxxxxxx) */
		*uchar = (unicode)src[0];
		return(1);
	}
	if (src[0] <= 0xDF) {			/* 0080-07FF: two bytes (110xxxxx 10xxxxxx) */
		*uchar = ((((unicode)src[0]) & 0x001F) << 6) |
					((((unicode)src[1]) & 0x003F) << 0);
		return(2);
	}
										/* 0800-FFFF: three bytes (1110xxxx 10xxxxxx 10xxxxxx) */
	*uchar = ((((unicode)src[0]) & 0x000F) << 12) |
				((((unicode)src[1]) & 0x003F) << 6) |
				((((unicode)src[2]) & 0x003F) << 0);
	return(3);
}

int
UTF8Encode(const unicode *src, unsigned char *dest)
{
	int src_idx = 0;
	int dest_idx = 0;

	while (src[src_idx] != 0) {
		dest_idx += UTF8EncodeChar(src[src_idx], dest + dest_idx);
		src_idx++;
	}
	dest[dest_idx] = '\0';
	return(dest_idx);
}

int 
UTF8Decode(const unsigned char *src, unicode *dest)
{
	int src_idx = 0;
	int dest_idx = 0;

	while (src[src_idx] != '\0') {
		src_idx += UTF8DecodeChar(src + src_idx, dest + dest_idx);
		dest_idx++;
	}
	dest[dest_idx] = 0;
	return(dest_idx);
}

HulaAgentStruct
*FindAgent(unsigned char *Executable)
{
	int		i;

	for (i=0; Agents[i].ShortName!=NULL; i++) {
		if (stricmp(Executable, Agents[i].Executable)==0) {
			return(&Agents[i]);
		}
	}
	return(NULL);
}

BOOL
StartAgent(HulaAgentStruct *Agent)
{
	SC_HANDLE		Service;
	int				Status;
	int				Success;
	unsigned char	Buffer[1024];

	Service = OpenService(Manager, Agent->ShortName, SERVICE_ALL_ACCESS);
	if (!Service) {
		Status=GetLastError();
		if (Status==ERROR_SERVICE_DOES_NOT_EXIST) {
			sprintf(Buffer, "Service '%s' not installed\n", Agent->ShortName);
		} else {
			sprintf(Buffer, "Error %d accessing service '%s'\n", Status, Agent->ShortName);
		}
		MessageBox(NULL, Buffer, PRODUCT_SHORT_NAME, MB_OK);
		return(FALSE);
	}

	Success=StartService(Service, 0, NULL);
	if (!Success) {
		Status=GetLastError();
		sprintf(Buffer, "Error %d starting service %s\n", Status, Agent->ShortName);
		MessageBox(NULL, Buffer, PRODUCT_SHORT_NAME, MB_OK);
	}
	CloseServiceHandle(Service);
	return(TRUE);
}


BOOL
StopAgent(HulaAgentStruct *Agent)
{
	SC_HANDLE		Service;
	SERVICE_STATUS	ServiceStatus;
	int				Status;
	int				Success;
	unsigned char	Buffer[1024];

	Service = OpenService(Manager, Agent->ShortName, SERVICE_ALL_ACCESS);
	if (!Service) {
		Status=GetLastError();
		if (Status==ERROR_SERVICE_DOES_NOT_EXIST) {
			sprintf(Buffer, "Service '%s' not installed\n", Agent->ShortName);
		} else {
			sprintf(Buffer, "Error %d accessing service '%s'\n", Status, Agent->ShortName);
		}
		MessageBox(NULL, Buffer, PRODUCT_SHORT_NAME, MB_OK);
		return(FALSE);
	}

	Success=ControlService(Service, SERVICE_CONTROL_STOP, &ServiceStatus);
	if (!Success) {
		Status=GetLastError();
		if (Status!=ERROR_SERVICE_NOT_ACTIVE) {
			printf("Error %d stopping service %s\n", Status, Agent->ShortName);
		}
	}
	CloseServiceHandle(Service);
	return(TRUE);
}


BOOL
ManageService(HulaAgentStruct *Agent, unsigned char *Path, BOOL Remove, unsigned char *Username, unsigned char *Password, BOOL DependsOnNDS)
{
	SC_HANDLE				Service;
	SERVICE_DESCRIPTION	Description;
	SERVICE_STATUS			ServiceStatus;
	int						Status;
	int						Success;
	unsigned char			Buffer[1024];
	OSVERSIONINFO			ovi;

	if (!Remove) {
		Service = CreateService(
			  Manager,							/* SCManager database 			*/
			  Agent->ShortName,				/* name of service 				*/
			  Agent->Name,						/* service name to display 	*/
			  SERVICE_ALL_ACCESS,			/* desired access 				*/
			  SERVICE_WIN32_OWN_PROCESS,	/* service type 					*/
			  Agent->AutoStart ? SERVICE_AUTO_START : SERVICE_DEMAND_START,			/* start type 						*/
			  SERVICE_ERROR_NORMAL,			/* error control type 			*/
			  Path,								/* service's binary 				*/
			  NULL,								/* no load ordering group 		*/
			  NULL,								/* no tag identifier 			*/
			  DependsOnNDS ? "NDS Server0\0\0" : NULL,										/* no dependencies 				*/
			  (!Username || Username[0]=='\0') ? NULL : Username,							/* LocalSystem account 			*/
			  (!Username || Username[0]=='\0') ? NULL : Password);						/* no password 					*/

		if (Service == NULL) {
			Status = GetLastError();
			sprintf(Buffer, "Failed to install service %s, error:%d\n", Agent->ShortName, Status);
			MessageBox(NULL, Buffer, PRODUCT_SHORT_NAME, MB_OK);
			return(FALSE);
		}
		sprintf(Buffer, "Service '%s' successfully installed\n", Agent->ShortName);
		//MessageBox(NULL, Buffer, PRODUCT_SHORT_NAME, MB_OK);

		ovi.dwOSVersionInfoSize=sizeof(OSVERSIONINFO);
		GetVersionEx(&ovi);
		if (ovi.dwPlatformId==VER_PLATFORM_WIN32_NT) {
			/* We've got NT, 2000, XP or .NET Server */
			if (ovi.dwMajorVersion>4) {
				HMODULE	AdvApi;
				FARPROC	ChangeFunc;

				AdvApi=LoadLibrary("advapi32.dll");
				if (AdvApi) {
					ChangeFunc=GetProcAddress(AdvApi, "ChangeServiceConfig2A");
					if (ChangeFunc) {
						Description.lpDescription=Agent->Description;
						ChangeFunc(Service, SERVICE_CONFIG_DESCRIPTION, (void *)&Description);
						//ChangeServiceConfig2(Service, SERVICE_CONFIG_DESCRIPTION, (void *)&Description);
					}
				}
			} else {
				AutoStart=FALSE;
			}
		}

		CloseServiceHandle(Service);
	} else {
		Service = OpenService(Manager, Agent->ShortName, SERVICE_ALL_ACCESS | DELETE);
		if (!Service) {
			Status=GetLastError();
			if (Status==ERROR_SERVICE_DOES_NOT_EXIST) {
				sprintf(Buffer, "Service '%s' not installed\n", Agent->ShortName);
			} else {
				sprintf(Buffer, "Error %d accessing service '%s'\n", Status, Agent->ShortName);
			}
			MessageBox(NULL, Buffer, PRODUCT_SHORT_NAME, MB_OK);
			return(FALSE);

		}

		Success=QueryServiceStatus(Service, &ServiceStatus);
		if (!Success) {
			Status=GetLastError();
			sprintf(Buffer, "Error %d retrieving service %s status\n", Status, Agent->ShortName);
			MessageBox(NULL, Buffer, PRODUCT_SHORT_NAME, MB_OK);
			CloseServiceHandle(Service);
			return(FALSE);
		}

		Success=ControlService(Service, SERVICE_CONTROL_STOP, &ServiceStatus);
		if (!Success) {
			Status=GetLastError();
			if (Status!=ERROR_SERVICE_NOT_ACTIVE) {
				sprintf(Buffer, "Error %d stopping service %s\n", Status, Agent->ShortName);
				MessageBox(NULL, Buffer, PRODUCT_SHORT_NAME, MB_OK);
			}
		}

		Success=DeleteService(Service);
		if (!Success) {
			Status=GetLastError();
			if (Status!=ERROR_SERVICE_MARKED_FOR_DELETE) {
				sprintf(Buffer, "Error %d removing service %s\n", Status, Agent->ShortName);
			} else {
				sprintf(Buffer, "Service %s already marked for deletion\n", Agent->ShortName);
			}
			MessageBox(NULL, Buffer, PRODUCT_SHORT_NAME, MB_OK);
		}
		CloseServiceHandle(Service);
	}
	return(TRUE);
}

BOOL
CreateServiceUser(unsigned char *Username, unsigned char *PasswordIn)
{
	USER_INFO_1						UserInfo;
	DWORD								Error;
	unicode							Name[256];
	unicode							Password[256+1];
	NET_API_STATUS					Result;
	LOCALGROUP_MEMBERS_INFO_3	Members;

	UTF8Decode(Username, Name);
	UTF8Decode(PasswordIn, Password);

	/* Check if user already exists */
	if (NetUserGetInfo(NULL, Name, 1, (LPBYTE *)&UserInfo)==NERR_Success) {
		/* User already exists, just set password for the guy */
		UserInfo.usri1_flags=UF_SCRIPT | UF_DONT_EXPIRE_PASSWD;
		UserInfo.usri1_password=Password;
		if ((Result=NetUserSetInfo(NULL, Name, 1, (LPBYTE)&UserInfo, NULL))!=NERR_Success) {
			sprintf((unsigned char *)Password, "User %s exists but cannot reset password. Error 0x%x.\n", Username, Result);
			MessageBox(NULL, (unsigned char *)Password, PRODUCT_SHORT_NAME, MB_OK | MB_ICONERROR);
			return(FALSE);
		}
		return(TRUE);
	}

	memset(&UserInfo, 0, sizeof(USER_INFO_1));
	UserInfo.usri1_name=Name;
	UserInfo.usri1_password=Password;
	UserInfo.usri1_priv=USER_PRIV_USER;
	UserInfo.usri1_flags=UF_SCRIPT | UF_DONT_EXPIRE_PASSWD;
	UserInfo.usri1_comment=L"Used by the Hula Service for logon";

	Result=NetUserAdd(NULL, 1, (LPBYTE)&UserInfo, &Error);
	if ((Result!=NERR_Success) && (Result!=NERR_UserExists)) {
		return(FALSE);
	}

	Members.lgrmi3_domainandname=Name;
	Result=NetLocalGroupAddMembers(NULL, L"Administrators", 3, (LPBYTE)&Members, 1);
	if (Result!=NERR_Success) {
		return(FALSE);
	}
	return(TRUE);
}

BOOL
RemoveServiceUser(unsigned char *Username)
{
	unicode							Name[256];

	UTF8Decode(Username, Name);

	NetUserDel(NULL, Name);

	return(TRUE);
}

#define	ACTION_START			1
#define	ACTION_REMOVE			2
#define	ACTION_INSTALL			3
#define	ACTION_STOP				4
#define	ACTION_AUTO				5
#define	ACTION_AUTO_REMOVE	6

int WINAPI
WinMain(HINSTANCE hInst, HINSTANCE hPrevInst, LPSTR CommandLine, int CmdShow)
{
	unsigned char			TempPath[_MAX_PATH];
	unsigned char			Path[_MAX_PATH];
	unsigned char			AdminUser[_MAX_PATH];
	unsigned char			AdminPassword[_MAX_PATH];
	int						Action=0;
	HulaAgentStruct		*Agent;
	BOOL						All=FALSE;
	int						Index;
	unsigned char			*CmdLine=NULL;
	unsigned char			*argv[20];
	unsigned char			argc=0;

//DebugBreak();

	AdminUser[0]='\0';
	AdminPassword[0]='\0';

	if (CommandLine && CommandLine[0]) {
		unsigned char	*ptr;

		CmdLine=strdup(CommandLine);

		ptr=CmdLine;
		argv[argc++]=PRODUCT_SHORT_NAME;
		argv[argc++]=ptr;
		while (!All) {
			switch (ptr[0]) {
				case '"': {
					ptr++;
					argv[argc-1]++;

					while (ptr[0] && ptr[0]!='"') {
						ptr++;
					}
					if (ptr[0]) {
						ptr[0]='\0';
						ptr++;
						while (isspace(ptr[0])) {
							ptr++;
						}
					}
					argv[argc++]=ptr;
					break;
				}

				case '\0': {
					All=TRUE;
					break;
				}

				case ' ': {
					ptr[0]='\0';
					ptr++;
					while (isspace(ptr[0])) {
						ptr++;
					}
					argv[argc++]=ptr;
					break;
				}

				default: {
					ptr++;
					break;
				}
			}
		}
	}

	All=FALSE;
	if (argc<3) {
		MessageBox(NULL, "syntax: hulaprep [-auto | -autoremove | -install | -remove | -start | -stop] [-all | agent] <hula bin path>\n", PRODUCT_SHORT_NAME, MB_OK);
		free(CmdLine);
		return(0);
	}

	if (stricmp(argv[1], "-auto")==0) {
		Action=ACTION_AUTO;
	} else if (stricmp(argv[1], "-install")==0) {
		Action=ACTION_INSTALL;
	} else if (stricmp(argv[1], "-remove")==0) {
		Action=ACTION_REMOVE;
	} else if (stricmp(argv[1], "-autoremove")==0) {
		Action=ACTION_AUTO_REMOVE;
	} else if (stricmp(argv[1], "-start")==0) {
		Action=ACTION_START;
	} else if (stricmp(argv[1], "-stop")==0) {
		Action=ACTION_STOP;
	} else {
		MessageBox(NULL, "syntax: hulaprep [-auto | -autoremove | -install | -remove | -start | -stop] [-all | agent] <hula bin path>\n", PRODUCT_SHORT_NAME, MB_OK);
		free(CmdLine);
		return(0);
	}

	if ((Action != ACTION_AUTO) && (Action != ACTION_AUTO_REMOVE)) {
		if (stricmp(argv[2], "-all")==0) {
			Agent=NULL;
			All=TRUE;
		} else {
			Agent=FindAgent(argv[2]);
			All=FALSE;
			if (!Agent) {
				sprintf(TempPath, "Did not find agent %s\n", argv[2]);
				MessageBox(NULL, TempPath, PRODUCT_SHORT_NAME, MB_OK);
				free(CmdLine);
				return(0);
			}
		}
		if (argc>3) {
			strcpy(TempPath, argv[3]);
			if (TempPath[strlen(TempPath)-1]=='\\') {
				TempPath[strlen(TempPath)-1]='\0';
			}
		} else {
			strcpy(TempPath, "c:\\program files\\hula\\bin");
		}

	} else {
		if (Action==ACTION_AUTO) {
			/* Arg2=path */
			Agent=FindAgent("hulamanager.exe");
			All=FALSE;

			strcpy(TempPath, argv[2]);
			if (TempPath[strlen(TempPath)-1]=='\\') {
				TempPath[strlen(TempPath)-1]='\0';
			}
		} else {
			/* Arg2=path */
			Agent=FindAgent("hulamanager.exe");
			All=FALSE;

			strcpy(TempPath, argv[2]);
			if (TempPath[strlen(TempPath)-1]=='\\') {
				TempPath[strlen(TempPath)-1]='\0';
			}
		}

	}

	Manager=OpenSCManager(NULL, NULL, SC_MANAGER_ALL_ACCESS);
	do {
		if (!Agent && All) {
			Index=0;
			Agent=&Agents[Index];
		}

		switch(Action) {
			case ACTION_START: {
				StartAgent(Agent);
				break;
			}

			case ACTION_STOP: {
				StopAgent(Agent);
				break;
			}

			case ACTION_AUTO: {
				unsigned char	Password[13];
				int				i;

				srand(time(NULL));
				for (i=0; i<12; i++) {
					Password[i]=(char)((rand() % 25) + 'A');
				}
				Password[12]='\0';

				if (CreateServiceUser(HULA_SERVICE_USER, Password)) {
					GrantServiceRights(HULA_SERVICE_USER);
				}

				sprintf(AdminUser, ".\\%s", HULA_SERVICE_USER);

				sprintf(Path, "\"%s\\%s\"", TempPath, Agent->Executable);
#if defined(HULAXE)
				if (ManageService(Agent, Path, FALSE, AdminUser, Password, FALSE))
#else
				if (ManageService(Agent, Path, FALSE, AdminUser, Password, TRUE))
#endif
				{
					if (AutoStart) {
						StartAgent(Agent);
					}
				}

				break;
			}

			case ACTION_INSTALL: {
				sprintf(Path, "\"%s\\%s\"", TempPath, Agent->Executable);
				ManageService(Agent, Path, FALSE, NULL, NULL, FALSE);
				break;
			}

			case ACTION_AUTO_REMOVE: {
				Agent=FindAgent("hulamanager.exe");
				// Fall through
				sprintf(Path, "\"%s\\%s\"", TempPath, Agent->Executable);
				ManageService(Agent, Path, TRUE, NULL, NULL, FALSE);

				RemoveServiceUser(HULA_SERVICE_USER);
				break;
			}

			case ACTION_REMOVE: {
				sprintf(Path, "\"%s\\%s\"", TempPath, Agent->Executable);
				ManageService(Agent, Path, TRUE, NULL, NULL, FALSE);
				break;
			}
		}
		if (All) {
			Index++;
			Agent=&Agents[Index];
		} else {
			Agent=NULL;
		}
	} while (Agent && Agent->ShortName);

	CloseServiceHandle(Manager);
	free(CmdLine);
	return(0);
}
#endif
